function mad_hid_tree_plot(p, genotype_str_array)
%  This function is modified based on the original treeplot function.
% The specific features:1.) use two different symbols to distinguish leaf nodes and branch
% nodes. 
% Author:Wenchao Zhang, The Samuel Roberts Noble Foundation.
% 12/28/2016     

[x,y,h]=treelayout(p);
f = find(p~=0);
pp = p(f);
X = [x(f); x(pp); NaN(size(f))];
Y = [y(f); y(pp); NaN(size(f))];

X = X(:);
Y = Y(:);

% determine the branch nodes and leaf nodes
% branch: 1, leaf :0
branch_leaf=zeros(1, length(p));
unique_p= unique(p);
branch_pos= unique_p(find(unique_p~=0));
branch_leaf(branch_pos)=1;

marker_count=1;
set_count=1;
figure;
for i_node=1:length(p)
    if(branch_leaf(i_node))
       marker_node=plot (x(i_node), y(i_node), 'rs', 'LineWidth',2);   %'rs'  'r^'   'LineWidth', 2,
       marker_name = cellstr(strcat('Marker',num2str(marker_count)));
       text(x(i_node), y(i_node), marker_name,'FontWeight', 'bold',  'FontSize', 10, 'VerticalAlignment','middle','HorizontalAlignment','left');
       marker_count= marker_count+1;
    else        
       leaf_node=plot (x(i_node), y(i_node), 'bo', 'LineWidth',2);  %'LineWidth', 2,
       leaf_name = cellstr(strcat('Sub\_Set',num2str(set_count)));
       text(x(i_node), y(i_node), leaf_name,'FontWeight', 'bold', 'FontSize', 10, 'Rotation', -90 ,'VerticalAlignment','middle','HorizontalAlignment','left');  %'right'
       set_count= set_count+1;
    end
hold on;
end
% Connect each nodes
plot(X, Y, 'k-', 'LineWidth',2);
% continur to text lable the genotype 

for i_node=2:length(p)
    hold on;    
    x_genotype =(x(i_node)+x(p(i_node)))/2.0;
    y_genotype =(y(i_node)+y(p(i_node)))/2.0;
    text(x_genotype, y_genotype, genotype_str_array(i_node-1),'FontWeight', 'bold', 'FontSize', 10, 'VerticalAlignment','middle','HorizontalAlignment','center', 'Color',[0.1 0.5 0.7]);
end

h_legend = legend([marker_node, leaf_node], 'Marker', 'Accesion Sub\_Set');
set(h_legend, 'FontWeight', 'bold', 'FontSize', 10, 'LineWidth',2);
axis off;
title('Plot of Hierarchical Decision Tree for Mulitple Accessions Distinguishment');
end



