% This is the top script file to plot the hierarchical tree that output
% from our web program MAD-HiDTree: www.bioinfo.noble.org/MAD-HiDtree/
% To use this script, you only need to pay attention the following 2 notices:
% Notice 1: Specific the script path;
% Notice 2: Specific the full name for the file of HiDTree.txt 
% Author: Wenchao Zhang, The Samuel Roberts Noble Foundation.
% 12/28/2016
clc;
clear all;
close all;
%Notice 1: in the foloowing line, Please specific the path that you downloaded the matlab script
Script_Path        ='C:\Users\wezhang\Desktop\Molecular_Marker_Rapid_Identification\Matlab_Script_HiDTree'; 
addpath(Script_Path);
%Note 2, If the HiDTree File did not locate with the script directory, pls change the following line
File_Name_Tree     = strcat(Script_Path, '\HiDTree.txt');    
File_Name_TreeID   = fopen(File_Name_Tree, 'rt');
tline=fgetl(File_Name_TreeID); % read header line
tline=fgetl(File_Name_TreeID);
Tree_Node_Vec=[];
Genotype_str_vec=[];
count=0;
while (tline~=-1)
    node=strsplit(tline, '\t');
    parent_index= str2num(char(node(3)));
    genotype    = cellstr(node(4));
    Tree_Node_Vec=[Tree_Node_Vec parent_index];
    if ~isempty(char(genotype))
      Genotype_str_vec=[Genotype_str_vec genotype];
    end
    tline=fgetl(File_Name_TreeID);
    count=count+1;
end

fclose(File_Name_TreeID);
mad_hid_tree_plot(Tree_Node_Vec, Genotype_str_vec); % call the tree plot function 
